namespace X3DTK {
namespace MESH {

template<class MData, class VData, class EData, class FData, bool readOnly>
MeshEditorMainWindow<MData, VData, EData, FData, readOnly>::MeshEditorMainWindow(QWidget *parent, const char *name, typename MeshMainWindow<MData, VData, EData, FData, readOnly>::WFlags fl)
: MeshMainWindow<MData, VData, EData, FData, readOnly>(parent, name, fl)
{
  _facesView = new FacesView<MData, VData, EData, FData, readOnly>(this); 
  _edgesView = new EdgesView<MData, VData, EData, FData, readOnly>(); 
  _verticesView = new VerticesView<MData, VData, EData, FData, readOnly>();
  _meshSelectionView = new MeshSelectionView<MData, VData, EData, FData, readOnly>();
  _normalsInversionView = new NormalsInversionView<MData, VData, EData, FData, readOnly>(this); 
  _normalsView = new NormalsView<MData, VData, EData, FData, readOnly>(this); 
  _connComView = new ConnComView<MData, VData, EData, FData, readOnly>(this);
  _statsView = new StatisticsView<MData, VData, EData, FData, readOnly>(this);
        
  _meshSelectionView->addView(_verticesView);
  _meshSelectionView->addView(_edgesView);
  _meshSelectionView->addView(_facesView);
  _meshSelectionView->addView(_normalsInversionView);
  _meshSelectionView->addView(_connComView);
  _meshSelectionView->addView(_statsView);
    
  meshViewer00->record(_facesView);
  meshViewer00->record(_edgesView);
  meshViewer00->record(_meshSelectionView);
  meshViewer00->record(_normalsInversionView);
  meshViewer00->record(_connComView);
  meshViewer00->record(_statsView);
  meshViewer10->record(_verticesView);
  meshViewer00->record(_normalsView);
    
  _facesView->show();
  _edgesView->show();
  _verticesView->show();
  _meshSelectionView->show();
  _normalsInversionView->show();
  _normalsView->show();
  _connComView->show();
  _statsView->show();
}

template<class MData, class VData, class EData, class FData, bool readOnly>
MeshEditorMainWindow<MData, VData, EData, FData, readOnly>::~MeshEditorMainWindow()
{
  delete _facesView; 
  delete _edgesView;   
  delete _verticesView;
  delete _normalsView;
  delete _meshSelectionView;
  delete _normalsInversionView;
  delete _connComView;
  delete _statsView;
}

}
}
