#include "MESH_Controller.h"
#include "MESH_View.h"

#include <Route.h>

using namespace std;

namespace X3DTK {
namespace MESH {

Controller::Controller()
: meshScene(0)
{
}

Controller::~Controller()
{
}

void Controller::record(View *element)
{
  if (element != 0)
    _viewList.push_back(element);
  
  element->_controller = this;
}

void Controller::remove(View *element)
{
  list<View *>::iterator it = find(_viewList.begin(), _viewList.end(), element);
  if (it != _viewList.end())
    _viewList.erase(it);
}

void Controller::notify()
{
  for (list<View *>::iterator it = _viewList.begin(); it != _viewList.end(); ++it)
    (*it)->receiveNotification();
  
  RC::Route::send(this, &Controller::updated); 
}

}
}
